#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ActivityKillCrabLotteryCFG.h"
std::auto_ptr<Fish_ActivityKillCrabLotteryCFG> Fish_ActivityKillCrabLotteryCFG::msSingleton(nullptr);

int Fish_ActivityKillCrabLotteryCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ActivityKillCrabLotteryCFGData* Fish_ActivityKillCrabLotteryCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ActivityKillCrabLotteryCFGData>& Fish_ActivityKillCrabLotteryCFG::GetMapData()
{
	return mMapData;
}

void Fish_ActivityKillCrabLotteryCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ActivityKillCrabLotteryCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ActivityKillCrabLotteryCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCostItemCount = element->IntAttribute("CostItemCount");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		{
			const char* AwardWeight = element->Attribute("AwardWeight");
			std::vector<std::string> vecAwardWeight;
			boost::split(vecAwardWeight, AwardWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardWeight[i].c_str(), &temp))
				{
					data.mAwardWeight.push_back(temp);
				}
			}
		}
		data.mHarmValueMin = element->IntAttribute("HarmValueMin");
		data.mHarmValueMax = element->IntAttribute("HarmValueMax");
		{
			const char* DisplayLabel = element->Attribute("DisplayLabel");
			std::vector<std::string> vecDisplayLabel;
			boost::split(vecDisplayLabel, DisplayLabel, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplayLabel.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplayLabel[i].c_str(), &temp))
				{
					data.mDisplayLabel.push_back(temp);
				}
			}
		}
		{
			const char* ShowAwardItemIDs = element->Attribute("ShowAwardItemIDs");
			std::vector<std::string> vecShowAwardItemIDs;
			boost::split(vecShowAwardItemIDs, ShowAwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowAwardItemIDs[i].c_str(), &temp))
				{
					data.mShowAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* ShowAwardItemCounts = element->Attribute("ShowAwardItemCounts");
			std::vector<std::string> vecShowAwardItemCounts;
			boost::split(vecShowAwardItemCounts, ShowAwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowAwardItemCounts[i].c_str(), &temp))
				{
					data.mShowAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mDisplayICON = element->Attribute("DisplayICON");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ActivityKillCrabLotteryCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ActivityKillCrabLotteryCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ActivityKillCrabLotteryCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ActivityKillCrabLotteryCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ActivityKillCrabLotteryCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "CostItemCount", data.mCostItemCount);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readVectorInt(L, "AwardWeight", data.mAwardWeight);
		LuaCfgHelper::readInt(L, "HarmValueMin", data.mHarmValueMin);
		LuaCfgHelper::readInt(L, "HarmValueMax", data.mHarmValueMax);
		LuaCfgHelper::readVectorInt(L, "DisplayLabel", data.mDisplayLabel);
		LuaCfgHelper::readVectorInt(L, "ShowAwardItemIDs", data.mShowAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "ShowAwardItemCounts", data.mShowAwardItemCounts);
		LuaCfgHelper::readString(L, "DisplayICON", data.mDisplayICON);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ActivityKillCrabLotteryCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ActivityKillCrabLotteryCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ActivityKillCrabLotteryCFG* Fish_ActivityKillCrabLotteryCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ActivityKillCrabLotteryCFG());
	}
	return msSingleton.get();
}

void Fish_ActivityKillCrabLotteryCFG::Release()
{
	msSingleton.reset(nullptr);
}
